// Xak2 (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x200*9*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,d;
	unsigned char id1[] = "Xak2_No";
	unsigned char id2[] = "Xak2_UD";

	// Disk 1
	struct fpos md1[] =
	{
		{ 0x48, 0x04, 0x0200 },	// SE
		{ 0x48, 0x05, 0x0800 },	// ɉh
		{ 0x37, 0x09, 0x0800 },	// É_
		{ 0x48, 0x09, 0x0600 },	// C^Cg
		{ 0x4a, 0x02, 0x0200 },	// 
		{ 0x4a, 0x03, 0x0800 }, // GfBO1
		{ 0x4a, 0x07, 0x0800 }, // GfBO2
		{ 0x4b, 0x02, 0x0400 }, // tCƃsNV[
		{ 0x4b, 0x06, 0x0200 }, // SE(The End)
		{ 0x4b, 0x07, 0x0200 }, // SE([)
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};
	struct fpos vd1[] =
	{
		{ 0x38, 0x04, 0x0400 },
		{ 0x48, 0x02, 0x0400 },
		{ 0x4b, 0x04, 0x0400 },
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	// Disk 3
	struct fpos md3[] =
	{
		{ 0x35, 0x05, 0x0400 }, // AIEYUEEENI
		{ 0x36, 0x09, 0x0200 }, // {Xf1
		{ 0x35, 0x08, 0x0200 }, // Q[I[o[
		{ 0x36, 0x02, 0x0600 }, // ok̒
		{ 0x36, 0x07, 0x0600 }, // IlV
		{ 0x35, 0x09, 0x0400 }, // ̐
		{ 0x34, 0x08, 0x0200 }, // Ȃ鋳
		{ 0x34, 0x09, 0x0200 }, // l(1)
		{ 0x35, 0x01, 0x0400 }, // l(2)
		{ 0x34, 0x03, 0x0600 }, // Q̋Vl
		{ 0x35, 0x07, 0x0200 }, // dΌ
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	struct fpos vd3[] =
	{
		{ 0x34, 0x06, 0x0400 }, // 
		{ 0x35, 0x03, 0x0400 }, // 
		{ 0x36, 0x05, 0x0400 }, // 
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	// Disk 4
	struct fpos md4[] =
	{
		{ 0x41, 0x07, 0x0800 }, // {[Y̐X
		{ 0x42, 0x05, 0x0200 }, // X̓A
		{ 0x42, 0x06, 0x0600 }, // V̋
		{ 0x41, 0x04, 0x0200 }, // ^EgD[NEX̖
		{ 0x42, 0x04, 0x0200 }, // P~[
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

/*
	struct fpos vd4[] =
	{
		{ 0x41, 0x05, 0x0400 },	// Disk 3ƉFf[^͓
		{ 0x42, 0x02, 0x0400 },
		{ 0x42, 0x09, 0x0400 },
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};
*/

	// Disk 5
	struct fpos md5[] =
	{
		{ 0x49, 0x05, 0x0400 }, // TAEKAEMIENIETE
		{ 0x49, 0x09, 0x0600 }, // ̌@
		{ 0x49, 0x02, 0x0200 }, // zvyih̋Y
		{ 0x4a, 0x03, 0x0600 }, // ₵P
		{ 0x4a, 0x06, 0x0600 }, // Ō̎
		{ 0x4a, 0x09, 0x0200 }, // BOSS OUT 2
		{ 0x4b, 0x01, 0x0200 }, // lŏII
		{ 0x4b, 0x02, 0x0400 }, // ΛIRSXy
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

/*
	struct fpos vd5[] =
	{
		{ 0x49, 0x03, 0x0400 }, // ̃fBXNƉFf[^͓
		{ 0x49, 0x07, 0x0400 },
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};
*/

	// Disk 6
	struct fpos md6[] =
	{
		{ 0x4c, 0x08, 0x0800 }, // Hs
		{ 0x4d, 0x02, 0x0200 }, // gbv
		{ 0x4d, 0x03, 0x0800 }, // JȄ
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

/*
	struct fpos vd6[] =
	{
		{ 0x4c, 0x09, 0x0400 }, // ̃fBXNƉFf[^͓
		{ 0x4d, 0x06, 0x0400 },
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};
*/
	// Disk 7
	struct fpos md7[] =
	{
		{ 0x45, 0x02, 0x0200 }, // `ɂ
		{ 0x47, 0x09, 0x0600 }, // fX}EeY
		{ 0x48, 0x08, 0x0400 }, // ĉEeF
		{ 0x45, 0x05, 0x0400 }, // QIC
		{ 0x46, 0x03, 0x0600 }, // PI
		{ 0x46, 0x08, 0x0400 }, // ԂƂ
		{ 0x45, 0x08, 0x0400 }, // Do
		{ 0x47, 0x01, 0x0600 }, // 
		{ 0x46, 0x06, 0x0400 }, // ̒n
		{ 0x48, 0x03, 0x0200 }, // ÂȂ鏟
		{ 0x48, 0x04, 0x0800 }, // ĉIu
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

/*
	struct fpos vd7[] =
	{
		{ 0x45, 0x03, 0x0400 }, // ̃fBXNƉFf[^͓
		{ 0x46, 0x01, 0x0400 },
		{ 0x47, 0x07, 0x0400 },
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};
*/

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x09);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x02, buff, 0x200);
		if (!memcmp(&buff[0x03],id1,sizeof(id1)-1))
		{
			switch(buff[0x0a])
			{
				case '8':
					printf("Disk 1 F܂.\n");
					for (i=0; md1[i].sec; i++)
					{
						sprintf(fname,"MUS1%02d",i);
						fcut(fname, md1[i].trk, md1[i].trk>>1, md1[i].trk&1, md1[i].sec, 0x02, 0x0000, md1[i].size);
					}
					for (i=0; vd1[i].sec; i++)
					{
						sprintf(fname,"VD1%02d",i);
						fcut(fname, vd1[i].trk, vd1[i].trk>>1, vd1[i].trk&1, vd1[i].sec, 0x02, 0x0000, vd1[i].size);
					}
					break;
				case '9':
					printf("Disk 2 F܂.\n");
					break;
				case '1':
					printf("Disk 3 F܂.\n");
					fcut("MMD.COM", 0x0c, 0x06, 0, 0x05, 0x02, 0x0000, 0xa00);
					for (i=0; md3[i].sec; i++)
					{
						sprintf(fname,"MUS3%02d",i);
						fcut(fname, md3[i].trk, md3[i].trk>>1, md3[i].trk&1, md3[i].sec, 0x02, 0x0000, md3[i].size);
					}
					for (i=0; vd3[i].sec; i++)
					{
						sprintf(fname,"VD3%02d",i);
						fcut(fname, vd3[i].trk, vd3[i].trk>>1, vd3[i].trk&1, vd3[i].sec, 0x02, 0x0000, vd3[i].size);
					}
					break;
				case '2':
					printf("Disk 4 F܂.\n");
					for (i=0; md4[i].sec; i++)
					{
						sprintf(fname,"MUS4%02d",i);
						fcut(fname, md4[i].trk, md4[i].trk>>1, md4[i].trk&1, md4[i].sec, 0x02, 0x0000, md4[i].size);
					}
					/* ̃fBXNƉFf[^͓
					for (i=0; vd4[i].sec; i++)
					{
						sprintf(fname,"VD4%02d",i);
						fcut(fname, vd4[i].trk, vd4[i].trk>>1, vd4[i].trk&1, vd4[i].sec, 0x02, 0x0000, vd4[i].size);
					}
					*/
					break;
				case '3':
					printf("Disk 5 F܂.\n");
					for (i=0; md5[i].sec; i++)
					{
						sprintf(fname,"MUS5%02d",i);
						fcut(fname, md5[i].trk, md5[i].trk>>1, md5[i].trk&1, md5[i].sec, 0x02, 0x0000, md5[i].size);
					}
					/* ̃fBXNƉFf[^͓
					for (i=0; vd5[i].sec; i++)
					{
						sprintf(fname,"VD5%02d",i);
						fcut(fname, vd5[i].trk, vd5[i].trk>>1, vd5[i].trk&1, vd5[i].sec, 0x02, 0x0000, vd5[i].size);
					}
					*/
					break;
				case '4':
					printf("Disk 6 F܂.\n");
					for (i=0; md6[i].sec; i++)
					{
						sprintf(fname,"MUS6%02d",i);
						fcut(fname, md6[i].trk, md6[i].trk>>1, md6[i].trk&1, md6[i].sec, 0x02, 0x0000, md6[i].size);
					}
					/* ̃fBXNƉFf[^͓
					for (i=0; vd6[i].sec; i++)
					{
						sprintf(fname,"VD6%02d",i);
						fcut(fname, vd6[i].trk, vd6[i].trk>>1, vd6[i].trk&1, vd6[i].sec, 0x02, 0x0000, vd6[i].size);
					}
					*/
					break;
				case '5':
					printf("Disk 7 F܂.\n");
					for (i=0; md7[i].sec; i++)
					{
						sprintf(fname,"MUS7%02d",i);
						fcut(fname, md7[i].trk, md7[i].trk>>1, md7[i].trk&1, md7[i].sec, 0x02, 0x0000, md7[i].size);
					}
					/* ̃fBXNƉFf[^͓
					for (i=0; vd7[i].sec; i++)
					{
						sprintf(fname,"VD7%02d",i);
						fcut(fname, vd7[i].trk, vd7[i].trk>>1, vd7[i].trk&1, vd7[i].sec, 0x02, 0x0000, vd7[i].size);
					}
					*/
					break;
			}
			continue;
		}
		else if (!memcmp(&buff[0x03],id2,sizeof(id2)-1))
		{
			printf("User DiskF܂.\n");
			continue;
		}
		printf("FłȂfBXNł.\n");
	}
	return 0;
}

